#include "cache.h"

CTlsData<ETOCache> Cache::etoCache;

bool Cache::ProcessInit() {
	return etoCache.ProcessInit();
}

void Cache::ProcessTerm() {
	return etoCache.ProcessTerm();
}

void Cache::ThreadTerm() {
	etoCache.ThreadTerm();
}

ETOCache* Cache::GetPtr() {
	return etoCache.GetPtr();
}

void ETOCache::FillSolidRect(COLORREF rgb) {
	rgb = RGB(GetBValue(rgb), GetGValue(rgb), GetRValue(rgb));
	DWORD* p = (DWORD*)lpPixels;
	DWORD* pend = p + (dibSize.cx * dibSize.cy);
	while(p < pend)
		*p++ = rgb;
}

HDC ETOCache::CreateDC()
{
	if (!hdc) {
		hdc = CreateCompatibleDC(NULL);
	}
	return hdc;
}

HBITMAP ETOCache::CreateDIB(int width, int height, BYTE** lplpPixels)
{
	if(dibSize.cx < width || dibSize.cy < height) {
		if(dibSize.cx > width)
			width = dibSize.cx;
		if(dibSize.cy > height)
			height = dibSize.cy;

		BITMAPINFOHEADER bmiHeader = {
			sizeof(bmiHeader),
			width,
			-height,
			1,
			32,
			BI_RGB,
		};

		HBITMAP hbmpNew = CreateDIBSection(CreateDC(), (CONST BITMAPINFO*)&bmiHeader, DIB_RGB_COLORS, (LPVOID*)lplpPixels, NULL, 0);
		if(!hbmpNew)
			return NULL;

		//shbmpTemp==NULL̏ꍇz肵A
		//Ƃ̂݃LbVXV
		if(hbmp) {
			DeleteObject(hbmp);
		}

		hbmp = hbmpNew;
		dibSize.cx = width;
		dibSize.cy = height;
		lpPixels = *lplpPixels;
 	}
	*lplpPixels = lpPixels;
	return hbmp;
}