#pragma once

#include "tlsdata.h"

// ExtTextOutW̃rbg}bvLbV
class ETOCache {
private:
	HDC		hdc;
	HBITMAP	hbmp;
	BYTE*	lpPixels;
	SIZE	dibSize;

public:
	ETOCache()
		: hdc(NULL),hbmp(NULL),lpPixels(NULL)
	{
		dibSize.cx = dibSize.cy = 0;
	}

	~ETOCache()
	{
		if(hdc)		DeleteDC(hdc);
		if(hbmp)	DeleteObject(hbmp);
	}

	const SIZE& Size() const
	{
		return dibSize;
	}
	BYTE* GetPixel()
	{
		//Assert(lpPixels != NULL);
		return lpPixels;
	}
	
	void FillSolidRect(COLORREF rgb);

	HDC CreateDC(void);
	HBITMAP CreateDIB(int width, int height, BYTE** lpPixels);
};

class Cache {
public:
	static bool ProcessInit(void);
	static void ProcessTerm(void);
	static void ThreadTerm(void);
	
	static ETOCache* GetPtr(void);
	
	static CTlsData<ETOCache> etoCache;
};
