#if defined(__SSE3__)
void ScaleDIBSSE3(ETOCache* pCache, BYTE* lpPixels, int width, int height) {
	int  srcWidthBytes = pCache->dibSize.cx * 4;
	int  srcSkipBytes  = srcWidthBytes - (width*4);
	int  dstSkipBytes  = srcWidthBytes - (width*4 / Settings::Scale);
	__m128i PZERO = _mm_setzero_si128();
	register BYTE* dst  = lpPixels;
	register BYTE* src0 = lpPixels;
	width  /= Settings::Scale;
	height /= Settings::Scale;
	
	for(int y=0 ; y < height ; y++) {
		register BYTE* src1 = src0 + srcWidthBytes;
		register BYTE* src2 = src1 + srcWidthBytes;
		register BYTE* src3 = src2 + srcWidthBytes;
		int x;
		int widtha;
		widtha = width&(~3);
		for(x=0 ; x < widtha ; x+=4) {
			__m128i XMM0, XMM1, XMM2, XMM3, XMM4, XMM5, XMM6;
			XMM0 = _mm_lddqu_si128((__m128i*)(src0   ));
			XMM1 = _mm_lddqu_si128((__m128i*)(src1   ));
			XMM4 = _mm_lddqu_si128((__m128i*)(src2   ));
			XMM5 = _mm_lddqu_si128((__m128i*)(src3   ));
			XMM2 = XMM0;
			XMM3 = XMM1;
			XMM6 = _mm_lddqu_si128((__m128i*)(src0+16));
			XMM0 = _mm_unpacklo_epi8(XMM0, PZERO);
			XMM1 = _mm_unpacklo_epi8(XMM1, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM3 = _mm_unpackhi_epi8(XMM3, PZERO);
			XMM0 = _mm_add_epi16(XMM0, XMM1);
			XMM1 = XMM4;
			XMM2 = _mm_add_epi16(XMM2, XMM3);
			XMM3 = XMM5;
			XMM4 = _mm_unpacklo_epi8(XMM4, PZERO);
			XMM5 = _mm_unpacklo_epi8(XMM5, PZERO);
			XMM1 = _mm_unpackhi_epi8(XMM1, PZERO);
			XMM3 = _mm_unpackhi_epi8(XMM3, PZERO);
			XMM4 = _mm_add_epi16(XMM4, XMM5);
			XMM5 = _mm_lddqu_si128((__m128i*)(src1+16));
			XMM1 = _mm_add_epi16(XMM1, XMM3);
			XMM3 = _mm_lddqu_si128((__m128i*)(src2+16));
			XMM0 = _mm_add_epi16(XMM0, XMM4);
			XMM4 = _mm_lddqu_si128((__m128i*)(src3+16));
			XMM2 = _mm_add_epi16(XMM2, XMM1);
			XMM1 = XMM6;
			XMM0 = _mm_add_epi16(XMM0, XMM2);
			XMM2 = XMM5;
			XMM6 = _mm_unpacklo_epi8(XMM6, PZERO);
			XMM5 = _mm_unpacklo_epi8(XMM5, PZERO);
			XMM1 = _mm_unpackhi_epi8(XMM1, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM6 = _mm_add_epi16(XMM6, XMM5);
			XMM5 = XMM3;
			XMM1 = _mm_add_epi16(XMM1, XMM2);
			XMM2 = XMM4;
			XMM3 = _mm_unpacklo_epi8(XMM3, PZERO);
			XMM4 = _mm_unpacklo_epi8(XMM4, PZERO);
			XMM5 = _mm_unpackhi_epi8(XMM5, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM3 = _mm_add_epi16(XMM3, XMM4);
			XMM4 = _mm_lddqu_si128((__m128i*)(src0+32));
			XMM5 = _mm_add_epi16(XMM5, XMM2);
			XMM2 = _mm_lddqu_si128((__m128i*)(src1+32));
			XMM6 = _mm_add_epi16(XMM6, XMM3);
			XMM3 = _mm_lddqu_si128((__m128i*)(src2+32));
			XMM1 = _mm_add_epi16(XMM1, XMM5);
			XMM5 = _mm_lddqu_si128((__m128i*)(src3+32));
			XMM6 = _mm_add_epi16(XMM6, XMM1);
			XMM1 = XMM0;
			XMM0 = _mm_castps_si128(_mm_shuffle_ps(
				_mm_castsi128_ps(XMM0), _mm_castsi128_ps(XMM6), _MM_SHUFFLE(3,2,1,0)));
			XMM1 = _mm_castps_si128(_mm_shuffle_ps(
				_mm_castsi128_ps(XMM1), _mm_castsi128_ps(XMM6), _MM_SHUFFLE(1,0,3,2)));
			XMM6 = XMM4;
			XMM0 = _mm_add_epi16(XMM0, XMM1);
			XMM1 = XMM2;
			XMM0 = _mm_srli_epi16(XMM0, 4);
			XMM4 = _mm_unpacklo_epi8(XMM4, PZERO);
			XMM2 = _mm_unpacklo_epi8(XMM2, PZERO);
			XMM0 = _mm_packus_epi16(XMM0, XMM0);
			XMM6 = _mm_unpackhi_epi8(XMM6, PZERO);
			XMM1 = _mm_unpackhi_epi8(XMM1, PZERO);
			_mm_storel_epi64((__m128i*)(dst   ), XMM0);
			XMM0 = _mm_lddqu_si128((__m128i*)(src0+48));
			XMM4 = _mm_add_epi16(XMM4, XMM2);
			XMM2 = XMM3;
			XMM6 = _mm_add_epi16(XMM6, XMM1);
			XMM1 = XMM5;
			XMM3 = _mm_unpacklo_epi8(XMM3, PZERO);
			XMM5 = _mm_unpacklo_epi8(XMM5, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM1 = _mm_unpackhi_epi8(XMM1, PZERO);
			XMM3 = _mm_add_epi16(XMM3, XMM5);
			XMM5 = _mm_lddqu_si128((__m128i*)(src1+48));
			XMM2 = _mm_add_epi16(XMM2, XMM1);
			XMM1 = _mm_lddqu_si128((__m128i*)(src2+48));
			XMM4 = _mm_add_epi16(XMM4, XMM3);
			XMM3 = _mm_lddqu_si128((__m128i*)(src3+48));
			XMM6 = _mm_add_epi16(XMM6, XMM2);
			XMM2 = XMM0;
			XMM4 = _mm_add_epi16(XMM4, XMM6);
			XMM6 = XMM5;
			XMM0 = _mm_unpacklo_epi8(XMM0, PZERO);
			XMM5 = _mm_unpacklo_epi8(XMM5, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM6 = _mm_unpackhi_epi8(XMM6, PZERO);
			XMM0 = _mm_add_epi16(XMM0, XMM5);
			XMM5 = XMM1;
			XMM2 = _mm_add_epi16(XMM2, XMM6);
			XMM6 = XMM3;
			XMM1 = _mm_unpacklo_epi8(XMM1, PZERO);
			XMM3 = _mm_unpacklo_epi8(XMM3, PZERO);
			XMM5 = _mm_unpackhi_epi8(XMM5, PZERO);
			XMM6 = _mm_unpackhi_epi8(XMM6, PZERO);
			XMM1 = _mm_add_epi16(XMM1, XMM3);
			XMM5 = _mm_add_epi16(XMM5, XMM6);
			XMM0 = _mm_add_epi16(XMM0, XMM1);
			XMM2 = _mm_add_epi16(XMM2, XMM5);
			XMM0 = _mm_add_epi16(XMM0, XMM2);
			XMM2 = XMM4;
			XMM4 = _mm_castps_si128(_mm_shuffle_ps(
				_mm_castsi128_ps(XMM4), _mm_castsi128_ps(XMM0), _MM_SHUFFLE(3,2,1,0)));
			XMM2 = _mm_castps_si128(_mm_shuffle_ps(
				_mm_castsi128_ps(XMM2), _mm_castsi128_ps(XMM0), _MM_SHUFFLE(1,0,3,2)));
			XMM4 = _mm_add_epi16(XMM4, XMM2);
			XMM4 = _mm_srli_epi16(XMM4, 4);
			XMM4 = _mm_packus_epi16(XMM4, XMM4);
			_mm_storel_epi64((__m128i*)(dst+ 8), XMM4);
			dst+=16; src0+=4*16; src1+=4*16; src2+=4*16; src3+=4*16;
		}
		widtha = width&(~1);
		for(    ; x < widtha ; x+=2) {
			__m128i XMM0, XMM1, XMM2, XMM3, XMM4, XMM5, XMM6;
			XMM0 = _mm_lddqu_si128((__m128i*)(src0   ));
			XMM1 = _mm_lddqu_si128((__m128i*)(src1   ));
			XMM4 = _mm_lddqu_si128((__m128i*)(src2   ));
			XMM5 = _mm_lddqu_si128((__m128i*)(src3   ));
			XMM2 = XMM0;
			XMM3 = XMM1;
			XMM6 = _mm_lddqu_si128((__m128i*)(src0+16));
			XMM0 = _mm_unpacklo_epi8(XMM0, PZERO);
			XMM1 = _mm_unpacklo_epi8(XMM1, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM3 = _mm_unpackhi_epi8(XMM3, PZERO);
			XMM0 = _mm_add_epi16(XMM0, XMM1);
			XMM1 = XMM4;
			XMM2 = _mm_add_epi16(XMM2, XMM3);
			XMM3 = XMM5;
			XMM4 = _mm_unpacklo_epi8(XMM4, PZERO);
			XMM5 = _mm_unpacklo_epi8(XMM5, PZERO);
			XMM1 = _mm_unpackhi_epi8(XMM1, PZERO);
			XMM3 = _mm_unpackhi_epi8(XMM3, PZERO);
			XMM4 = _mm_add_epi16(XMM4, XMM5);
			XMM5 = _mm_lddqu_si128((__m128i*)(src1+16));
			XMM1 = _mm_add_epi16(XMM1, XMM3);
			XMM3 = _mm_lddqu_si128((__m128i*)(src2+16));
			XMM0 = _mm_add_epi16(XMM0, XMM4);
			XMM4 = _mm_lddqu_si128((__m128i*)(src3+16));
			XMM2 = _mm_add_epi16(XMM2, XMM1);
			XMM1 = XMM6;
			XMM0 = _mm_add_epi16(XMM0, XMM2);
			XMM2 = XMM5;
			XMM6 = _mm_unpacklo_epi8(XMM6, PZERO);
			XMM5 = _mm_unpacklo_epi8(XMM5, PZERO);
			XMM1 = _mm_unpackhi_epi8(XMM1, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM6 = _mm_add_epi16(XMM6, XMM5);
			XMM5 = XMM3;
			XMM1 = _mm_add_epi16(XMM1, XMM2);
			XMM2 = XMM4;
			XMM3 = _mm_unpacklo_epi8(XMM3, PZERO);
			XMM4 = _mm_unpacklo_epi8(XMM4, PZERO);
			XMM5 = _mm_unpackhi_epi8(XMM5, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM3 = _mm_add_epi16(XMM3, XMM4);
			XMM5 = _mm_add_epi16(XMM5, XMM2);
			XMM6 = _mm_add_epi16(XMM6, XMM3);
			XMM1 = _mm_add_epi16(XMM1, XMM5);
			XMM6 = _mm_add_epi16(XMM6, XMM1);
			XMM1 = XMM0;
			XMM0 = _mm_castps_si128(_mm_shuffle_ps(
				_mm_castsi128_ps(XMM0), _mm_castsi128_ps(XMM6), _MM_SHUFFLE(3,2,1,0)));
			XMM1 = _mm_castps_si128(_mm_shuffle_ps(
				_mm_castsi128_ps(XMM1), _mm_castsi128_ps(XMM6), _MM_SHUFFLE(1,0,3,2)));
			XMM0 = _mm_add_epi16(XMM0, XMM1);
			XMM0 = _mm_srli_epi16(XMM0, 4);
			XMM0 = _mm_packus_epi16(XMM0, XMM0);
			_mm_storel_epi64((__m128i*)(dst   ), XMM0);
			dst+=8; src0+=4*8; src1+=4*8; src2+=4*8; src3+=4*8;
		}
		for(    ; x < width ; x++) {
			__m128i XMM0, XMM1, XMM2, XMM3, XMM4, XMM5;
			XMM0 = _mm_lddqu_si128((__m128i*)(src0   ));
			XMM1 = _mm_lddqu_si128((__m128i*)(src1   ));
			XMM4 = _mm_lddqu_si128((__m128i*)(src2   ));
			XMM5 = _mm_lddqu_si128((__m128i*)(src3   ));
			XMM2 = XMM0;
			XMM3 = XMM1;
			XMM0 = _mm_unpacklo_epi8(XMM0, PZERO);
			XMM1 = _mm_unpacklo_epi8(XMM1, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM3 = _mm_unpackhi_epi8(XMM3, PZERO);
			XMM0 = _mm_add_epi16(XMM0, XMM1);
			XMM1 = XMM4;
			XMM2 = _mm_add_epi16(XMM2, XMM3);
			XMM3 = XMM5;
			XMM4 = _mm_unpacklo_epi8(XMM4, PZERO);
			XMM5 = _mm_unpacklo_epi8(XMM5, PZERO);
			XMM1 = _mm_unpackhi_epi8(XMM1, PZERO);
			XMM3 = _mm_unpackhi_epi8(XMM3, PZERO);
			XMM4 = _mm_add_epi16(XMM4, XMM5);
			XMM1 = _mm_add_epi16(XMM1, XMM3);
			XMM0 = _mm_add_epi16(XMM0, XMM4);
			XMM2 = _mm_add_epi16(XMM2, XMM1);
			XMM0 = _mm_add_epi16(XMM0, XMM2);
			XMM2 = _mm_castps_si128(_mm_movehl_ps(_mm_castsi128_ps(XMM2), _mm_castsi128_ps(XMM0)));
			XMM0 = _mm_add_epi16(XMM0, XMM2);
			XMM0 = _mm_srli_epi16(XMM0, 4);
			XMM0 = _mm_packus_epi16(XMM0, XMM0);
			_mm_store_ss((float*)(dst   ), _mm_castsi128_ps(XMM0));
			dst+=4; src0+=4*4; src1+=4*4; src2+=4*4; src3+=4*4;
		}
		dst += dstSkipBytes;
		src0 = src3 + srcSkipBytes;
	}
}
#endif

#if defined(__SSE2__)
void ScaleDIBSSE2(ETOCache* pCache, BYTE* lpPixels, int width, int height) {
	int  srcWidthBytes = pCache->dibSize.cx * 4;
	int  srcSkipBytes  = srcWidthBytes - (width*4);
	int  dstSkipBytes  = srcWidthBytes - (width*4 / Settings::Scale);
	__m128i PZERO = _mm_setzero_si128();
	register BYTE* dst  = lpPixels;
	register BYTE* src0 = lpPixels;
	width  /= Settings::Scale;
	height /= Settings::Scale;
	
	for(int y=0 ; y < height ; y++) {
		register BYTE* src1 = src0 + srcWidthBytes;
		register BYTE* src2 = src1 + srcWidthBytes;
		register BYTE* src3 = src2 + srcWidthBytes;
		int x;
		int widtha;
		widtha = width&(~3);
		for(x=0 ; x < widtha ; x+=4) {
			__m128i XMM0, XMM1, XMM2, XMM3, XMM4, XMM5, XMM6;
			XMM0 = _mm_loadu_si128((__m128i*)(src0   ));
			XMM1 = _mm_loadu_si128((__m128i*)(src1   ));
			XMM4 = _mm_loadu_si128((__m128i*)(src2   ));
			XMM5 = _mm_loadu_si128((__m128i*)(src3   ));
			XMM2 = XMM0;
			XMM3 = XMM1;
			XMM6 = _mm_loadu_si128((__m128i*)(src0+16));
			XMM0 = _mm_unpacklo_epi8(XMM0, PZERO);
			XMM1 = _mm_unpacklo_epi8(XMM1, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM3 = _mm_unpackhi_epi8(XMM3, PZERO);
			XMM0 = _mm_add_epi16(XMM0, XMM1);
			XMM1 = XMM4;
			XMM2 = _mm_add_epi16(XMM2, XMM3);
			XMM3 = XMM5;
			XMM4 = _mm_unpacklo_epi8(XMM4, PZERO);
			XMM5 = _mm_unpacklo_epi8(XMM5, PZERO);
			XMM1 = _mm_unpackhi_epi8(XMM1, PZERO);
			XMM3 = _mm_unpackhi_epi8(XMM3, PZERO);
			XMM4 = _mm_add_epi16(XMM4, XMM5);
			XMM5 = _mm_loadu_si128((__m128i*)(src1+16));
			XMM1 = _mm_add_epi16(XMM1, XMM3);
			XMM3 = _mm_loadu_si128((__m128i*)(src2+16));
			XMM0 = _mm_add_epi16(XMM0, XMM4);
			XMM4 = _mm_loadu_si128((__m128i*)(src3+16));
			XMM2 = _mm_add_epi16(XMM2, XMM1);
			XMM1 = XMM6;
			XMM0 = _mm_add_epi16(XMM0, XMM2);
			XMM2 = XMM5;
			XMM6 = _mm_unpacklo_epi8(XMM6, PZERO);
			XMM5 = _mm_unpacklo_epi8(XMM5, PZERO);
			XMM1 = _mm_unpackhi_epi8(XMM1, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM6 = _mm_add_epi16(XMM6, XMM5);
			XMM5 = XMM3;
			XMM1 = _mm_add_epi16(XMM1, XMM2);
			XMM2 = XMM4;
			XMM3 = _mm_unpacklo_epi8(XMM3, PZERO);
			XMM4 = _mm_unpacklo_epi8(XMM4, PZERO);
			XMM5 = _mm_unpackhi_epi8(XMM5, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM3 = _mm_add_epi16(XMM3, XMM4);
			XMM4 = _mm_loadu_si128((__m128i*)(src0+32));
			XMM5 = _mm_add_epi16(XMM5, XMM2);
			XMM2 = _mm_loadu_si128((__m128i*)(src1+32));
			XMM6 = _mm_add_epi16(XMM6, XMM3);
			XMM3 = _mm_loadu_si128((__m128i*)(src2+32));
			XMM1 = _mm_add_epi16(XMM1, XMM5);
			XMM5 = _mm_loadu_si128((__m128i*)(src3+32));
			XMM6 = _mm_add_epi16(XMM6, XMM1);
			XMM1 = XMM0;
			XMM0 = _mm_castps_si128(_mm_shuffle_ps(
				_mm_castsi128_ps(XMM0), _mm_castsi128_ps(XMM6), _MM_SHUFFLE(3,2,1,0)));
			XMM1 = _mm_castps_si128(_mm_shuffle_ps(
				_mm_castsi128_ps(XMM1), _mm_castsi128_ps(XMM6), _MM_SHUFFLE(1,0,3,2)));
			XMM6 = XMM4;
			XMM0 = _mm_add_epi16(XMM0, XMM1);
			XMM1 = XMM2;
			XMM0 = _mm_srli_epi16(XMM0, 4);
			XMM4 = _mm_unpacklo_epi8(XMM4, PZERO);
			XMM2 = _mm_unpacklo_epi8(XMM2, PZERO);
			XMM0 = _mm_packus_epi16(XMM0, XMM0);
			XMM6 = _mm_unpackhi_epi8(XMM6, PZERO);
			XMM1 = _mm_unpackhi_epi8(XMM1, PZERO);
			_mm_storel_epi64((__m128i*)(dst   ), XMM0);
			XMM0 = _mm_loadu_si128((__m128i*)(src0+48));
			XMM4 = _mm_add_epi16(XMM4, XMM2);
			XMM2 = XMM3;
			XMM6 = _mm_add_epi16(XMM6, XMM1);
			XMM1 = XMM5;
			XMM3 = _mm_unpacklo_epi8(XMM3, PZERO);
			XMM5 = _mm_unpacklo_epi8(XMM5, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM1 = _mm_unpackhi_epi8(XMM1, PZERO);
			XMM3 = _mm_add_epi16(XMM3, XMM5);
			XMM5 = _mm_loadu_si128((__m128i*)(src1+48));
			XMM2 = _mm_add_epi16(XMM2, XMM1);
			XMM1 = _mm_loadu_si128((__m128i*)(src2+48));
			XMM4 = _mm_add_epi16(XMM4, XMM3);
			XMM3 = _mm_loadu_si128((__m128i*)(src3+48));
			XMM6 = _mm_add_epi16(XMM6, XMM2);
			XMM2 = XMM0;
			XMM4 = _mm_add_epi16(XMM4, XMM6);
			XMM6 = XMM5;
			XMM0 = _mm_unpacklo_epi8(XMM0, PZERO);
			XMM5 = _mm_unpacklo_epi8(XMM5, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM6 = _mm_unpackhi_epi8(XMM6, PZERO);
			XMM0 = _mm_add_epi16(XMM0, XMM5);
			XMM5 = XMM1;
			XMM2 = _mm_add_epi16(XMM2, XMM6);
			XMM6 = XMM3;
			XMM1 = _mm_unpacklo_epi8(XMM1, PZERO);
			XMM3 = _mm_unpacklo_epi8(XMM3, PZERO);
			XMM5 = _mm_unpackhi_epi8(XMM5, PZERO);
			XMM6 = _mm_unpackhi_epi8(XMM6, PZERO);
			XMM1 = _mm_add_epi16(XMM1, XMM3);
			XMM5 = _mm_add_epi16(XMM5, XMM6);
			XMM0 = _mm_add_epi16(XMM0, XMM1);
			XMM2 = _mm_add_epi16(XMM2, XMM5);
			XMM0 = _mm_add_epi16(XMM0, XMM2);
			XMM2 = XMM4;
			XMM4 = _mm_castps_si128(_mm_shuffle_ps(
				_mm_castsi128_ps(XMM4), _mm_castsi128_ps(XMM0), _MM_SHUFFLE(3,2,1,0)));
			XMM2 = _mm_castps_si128(_mm_shuffle_ps(
				_mm_castsi128_ps(XMM2), _mm_castsi128_ps(XMM0), _MM_SHUFFLE(1,0,3,2)));
			XMM4 = _mm_add_epi16(XMM4, XMM2);
			XMM4 = _mm_srli_epi16(XMM4, 4);
			XMM4 = _mm_packus_epi16(XMM4, XMM4);
			_mm_storel_epi64((__m128i*)(dst+ 8), XMM4);
			dst+=16; src0+=4*16; src1+=4*16; src2+=4*16; src3+=4*16;
		}
		widtha = width&(~1);
		for(    ; x < widtha ; x+=2) {
			__m128i XMM0, XMM1, XMM2, XMM3, XMM4, XMM5, XMM6;
			XMM0 = _mm_loadu_si128((__m128i*)(src0   ));
			XMM1 = _mm_loadu_si128((__m128i*)(src1   ));
			XMM4 = _mm_loadu_si128((__m128i*)(src2   ));
			XMM5 = _mm_loadu_si128((__m128i*)(src3   ));
			XMM2 = XMM0;
			XMM3 = XMM1;
			XMM6 = _mm_loadu_si128((__m128i*)(src0+16));
			XMM0 = _mm_unpacklo_epi8(XMM0, PZERO);
			XMM1 = _mm_unpacklo_epi8(XMM1, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM3 = _mm_unpackhi_epi8(XMM3, PZERO);
			XMM0 = _mm_add_epi16(XMM0, XMM1);
			XMM1 = XMM4;
			XMM2 = _mm_add_epi16(XMM2, XMM3);
			XMM3 = XMM5;
			XMM4 = _mm_unpacklo_epi8(XMM4, PZERO);
			XMM5 = _mm_unpacklo_epi8(XMM5, PZERO);
			XMM1 = _mm_unpackhi_epi8(XMM1, PZERO);
			XMM3 = _mm_unpackhi_epi8(XMM3, PZERO);
			XMM4 = _mm_add_epi16(XMM4, XMM5);
			XMM5 = _mm_loadu_si128((__m128i*)(src1+16));
			XMM1 = _mm_add_epi16(XMM1, XMM3);
			XMM3 = _mm_loadu_si128((__m128i*)(src2+16));
			XMM0 = _mm_add_epi16(XMM0, XMM4);
			XMM4 = _mm_loadu_si128((__m128i*)(src3+16));
			XMM2 = _mm_add_epi16(XMM2, XMM1);
			XMM1 = XMM6;
			XMM0 = _mm_add_epi16(XMM0, XMM2);
			XMM2 = XMM5;
			XMM6 = _mm_unpacklo_epi8(XMM6, PZERO);
			XMM5 = _mm_unpacklo_epi8(XMM5, PZERO);
			XMM1 = _mm_unpackhi_epi8(XMM1, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM6 = _mm_add_epi16(XMM6, XMM5);
			XMM5 = XMM3;
			XMM1 = _mm_add_epi16(XMM1, XMM2);
			XMM2 = XMM4;
			XMM3 = _mm_unpacklo_epi8(XMM3, PZERO);
			XMM4 = _mm_unpacklo_epi8(XMM4, PZERO);
			XMM5 = _mm_unpackhi_epi8(XMM5, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM3 = _mm_add_epi16(XMM3, XMM4);
			XMM5 = _mm_add_epi16(XMM5, XMM2);
			XMM6 = _mm_add_epi16(XMM6, XMM3);
			XMM1 = _mm_add_epi16(XMM1, XMM5);
			XMM6 = _mm_add_epi16(XMM6, XMM1);
			XMM1 = XMM0;
			XMM0 = _mm_castps_si128(_mm_shuffle_ps(
				_mm_castsi128_ps(XMM0), _mm_castsi128_ps(XMM6), _MM_SHUFFLE(3,2,1,0)));
			XMM1 = _mm_castps_si128(_mm_shuffle_ps(
				_mm_castsi128_ps(XMM1), _mm_castsi128_ps(XMM6), _MM_SHUFFLE(1,0,3,2)));
			XMM0 = _mm_add_epi16(XMM0, XMM1);
			XMM0 = _mm_srli_epi16(XMM0, 4);
			XMM0 = _mm_packus_epi16(XMM0, XMM0);
			_mm_storel_epi64((__m128i*)(dst   ), XMM0);
			dst+=8; src0+=4*8; src1+=4*8; src2+=4*8; src3+=4*8;
		}
		for(    ; x < width ; x++) {
			__m128i XMM0, XMM1, XMM2, XMM3, XMM4, XMM5;
			XMM0 = _mm_loadu_si128((__m128i*)(src0   ));
			XMM1 = _mm_loadu_si128((__m128i*)(src1   ));
			XMM4 = _mm_loadu_si128((__m128i*)(src2   ));
			XMM5 = _mm_loadu_si128((__m128i*)(src3   ));
			XMM2 = XMM0;
			XMM3 = XMM1;
			XMM0 = _mm_unpacklo_epi8(XMM0, PZERO);
			XMM1 = _mm_unpacklo_epi8(XMM1, PZERO);
			XMM2 = _mm_unpackhi_epi8(XMM2, PZERO);
			XMM3 = _mm_unpackhi_epi8(XMM3, PZERO);
			XMM0 = _mm_add_epi16(XMM0, XMM1);
			XMM1 = XMM4;
			XMM2 = _mm_add_epi16(XMM2, XMM3);
			XMM3 = XMM5;
			XMM4 = _mm_unpacklo_epi8(XMM4, PZERO);
			XMM5 = _mm_unpacklo_epi8(XMM5, PZERO);
			XMM1 = _mm_unpackhi_epi8(XMM1, PZERO);
			XMM3 = _mm_unpackhi_epi8(XMM3, PZERO);
			XMM4 = _mm_add_epi16(XMM4, XMM5);
			XMM1 = _mm_add_epi16(XMM1, XMM3);
			XMM0 = _mm_add_epi16(XMM0, XMM4);
			XMM2 = _mm_add_epi16(XMM2, XMM1);
			XMM0 = _mm_add_epi16(XMM0, XMM2);
			XMM2 = _mm_castps_si128(_mm_movehl_ps(_mm_castsi128_ps(XMM2), _mm_castsi128_ps(XMM0)));
			XMM0 = _mm_add_epi16(XMM0, XMM2);
			XMM0 = _mm_srli_epi16(XMM0, 4);
			XMM0 = _mm_packus_epi16(XMM0, XMM0);
			_mm_store_ss((float*)(dst   ), _mm_castsi128_ps(XMM0));
			dst+=4; src0+=4*4; src1+=4*4; src2+=4*4; src3+=4*4;
		}
		dst += dstSkipBytes;
		src0 = src3 + srcSkipBytes;
	}
}
#endif